/*********************************************************************
*                                                                    *          
*                              FLY                                   *
*                           --E#Y#E--				     *
*                         (==MUSCLE==)                               *
*                                                                    *
*********************************************************************/

/* C++ Header Files */
#include <map>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <fstream>
#include <iostream>
#include <vector>
#include <cmath>
/* OpenGL */
#include <GL/glew.h>
#include <GL/gl.h>
#include <GL/glx.h>
#include <GL/glu.h>
/* Flysimulator */
#include "WIN/help.h"
#include "WIN/win.h"
#include "WIN/opengl.h"
#include "WIN/cockpit.h"
#include "WIN/fps.h"

/* Define Key */
#define XK_space                         0x0020
#define XK_Escape                        0xff1b
#define XK_F1                            0xffbe
#define XK_F2                            0xffbf
#define XK_F3				 0xffc0
#define XK_F4				 0xffc1
#define XK_Left                          0xff51 
#define XK_Right                         0xff53
#define XK_Up                            0xff52  
#define XK_Down                          0xff54  
#define XK_a                             0x0061
#define XK_b                             0x0062
#define XK_d                             0x0064
#define XK_e                             0x0065
#define XK_q                             0x0071 
#define XK_s                             0x0073 
#define XK_w                             0x0077
#define XK_n                             0x006e
#define XK_m                             0x006d

//---------------------------------------------------------------------------

bool wide, texture, grid, cloud, night, fversion, fhelp = false;

WIND wind;
FLY fly;
MOD mod;
FPS fps;
HELP help;

//---------------------------------------------------------------------------

/* Main Program */
int main (int egac, char **egav) 
{
	/* Console Settings */	
	int n = 0;
	int f = 0;
	
	for(n = 0; n < egac; n++)
	{
		for(f = 0; f < egav[n][f]; ++f)
		{
			switch(egav[n][f])    
			{
				case 'F':
				wide = true;
				break;

				case 'T':
				texture = true;
				break;
				
				case 'G':
				grid = true;
				break;

				case 'C':
				cloud = true;
				break;	
				
				case 'N':
				night = true;
				break;				
				
				case 'v':
				fversion = true;
				break;
				
				case 'h':
				fhelp = true;
				break;
			}
		}
	}
	
	//-------------------------------------------------------------------

	/* Create Window */
	wind.createWin(wide);
	fps.InitTimeCounter();
	fly.loadTexture();

	/* Render */
	while(texture)
	{
		/* Landscape */		
		fly.initLand(night);
		fly.Landscape(cloud);
		/* Cockpit */
		mod.Motor();
		mod.Cockpit();
		/* Display */		
		wind.perspective();
		wind.eventloop();
		wind.loadFont();	
		/* FPS */
		fps.CalculateFPS();
		fps.UpdateTimeCounter();	
	}

	//-------------------------------------------------------------------

	/* Render */
	while(grid)
	{
		/* Grid */		
		fly.initGrid();
		fly.GridView();
		/* Cockpit */
		mod.Motor();
		mod.Cockpit();
		/* Display */		
		wind.perspective();
		wind.eventloop();
		wind.loadFont();	
		/* FPS */
		fps.CalculateFPS();
		fps.UpdateTimeCounter();	
	}
		 
	//-------------------------------------------------------------------
	 
	/* Show Help Desk */
	if(fhelp)
	{
		help.Desk(egac);
	}

	/* Display Version */
	else if(fversion)
	{
		help.version();
	}
	 
	return 0;
}

//---------------------------------------------------------------------------


